Index: indications.c
===================================================================
RCS file: indications.c,v
retrieving revision 1.24
diff -u -r1.24 indications.c
--- indications.c	22 Apr 2005 13:11:34 -0000	1.24
+++ indications.c	3 Jun 2005 03:38:40 -0000
@@ -174,7 +174,7 @@
 		separator = ",";
 	s = strsep(&stringp,separator);
 	while (s && *s) {
-		int freq1, freq2, time, modulate=0;
+		int freq1, freq2, time, modulate=0, midinote=0;
 
 		if (s[0]=='!')
 			s++;
@@ -199,9 +199,47 @@
 			/* f1 format */
 			freq2 = 0;
 			time = 0;
+		} else if (sscanf(s, "M%d+M%d/%d", &freq1, &freq2, &time) == 3) {
+			/* Mf1+Mf2/time format */
+			midinote = 1;
+		} else if (sscanf(s, "M%d+M%d", &freq1, &freq2) == 2) {
+			/* Mf1+Mf2 format */
+			time = 0;
+			midinote = 1;
+		} else if (sscanf(s, "M%d*M%d/%d", &freq1, &freq2, &time) == 3) {
+			/* Mf1*Mf2/time format */
+			modulate = 1;
+			midinote = 1;
+		} else if (sscanf(s, "M%d*M%d", &freq1, &freq2) == 2) {
+			/* Mf1*Mf2 format */
+			time = 0;
+			modulate = 1;
+			midinote = 1;
+		} else if (sscanf(s, "M%d/%d", &freq1, &time) == 2) {
+			/* Mf1/time format */
+			freq2 = -1;
+			midinote = 1;
+		} else if (sscanf(s, "M%d", &freq1) == 1) {
+			/* Mf1 format */
+			freq2 = -1;
+			time = 0;
+			midinote = 1;
 		} else {
 			ast_log(LOG_WARNING,"%s: tone component '%s' of '%s' is no good\n",chan->name,s,playlst);
 			return -1;
+		}
+
+		if (midinote) {
+			/* midi notes must be between 0 and 127 */
+			if (freq1 >= 0 || freq1 <= 127)
+				freq1 = (8.1758 * pow(2, (freq1/12.0)));
+			else
+				freq1 = 0;
+
+			if (freq2 >= 0 || freq2 <= 127)
+				freq2 = (8.1758 * pow(2,(freq2/12.0)));
+			else
+				freq2 = 0;
 		}
 
 		d.items = realloc(d.items,(d.nitems+1)*sizeof(struct playtones_item));
